stages:
 - build
# - test
# - quality
# - sonarcloud
 - package
 - deploy
 - performance

#variables:
#  PLAYWD: ip172-18-0-220-bsudh05im9m000d4e440

cache:
 paths:
  - .m2/repository
 key: "$CI_JOB_NAME"

build_job:
 stage: build
 script:
  - ./mvnw compile
    -Dhttps.protocols=TLSv1.2
    -Dmaven.repo.local=$CI_PROJECT_DIR/.m2/repository
    -Dorg.slf4j.simpleLogger.log.org.apache.maven.cli.transfer.Slf4jMavenTransferListener=WARN
    -Dorg.slf4j.simpleLogger.showDateTime=true
    -Djava.awt.headless=true
    --batch-mode --errors --fail-at-end --show-version -DinstallAtEnd=true -DdeployAtEnd=true
 image: openjdk:8-alpine

#test_job:
#  stage: test
#  script:
#    - ./mvnw test
#      -Dhttps.protocols=TLSv1.2
#      -Dmaven.repo.local=$CI_PROJECT_DIR/.m2/repository
#      -Dorg.slf4j.simpleLogger.log.org.apache.maven.cli.transfer.Slf4jMavenTransferListener=WARN
#      -Dorg.slf4j.simpleLogger.showDateTime=true
#      -Djava.awt.headless=true
#      --batch-mode --errors --fail-at-end --show-version -DinstallAtEnd=true -DdeployAtEnd=true
#  image: openjdk:8-alpine

#code_quality_job:
#  stage: quality
#  image: docker:stable
#  allow_failure: true
#  services:
#    - docker:stable-dind
#  script:
#    - mkdir codequality-results
#    - docker run
#        --env CODECLIMATE_CODE="$PWD"
#        --volume "$PWD":/code
#        --volume /var/run/docker.sock:/var/run/docker.sock
#        --volume /tmp/cc:/tmp/cc
#        codeclimate/codeclimate analyze -f html > ./codequality-results/index.html
#  artifacts:
#    paths:
#      - codequality-results/
 
package_job:
  stage: package
  services:
    - docker:stable-dind
  variables:
    DOCKER_HOST: tcp://docker:2375
  script:
    - apk add --no-cache docker
    - docker login -u gitlab-ci-token -p $CI_JOB_TOKEN $CI_REGISTRY
    - ./mvnw install -PbuildDocker -DskipTests=true -DpushImage
      -Dhttps.protocols=TLSv1.2
      -Dmaven.repo.local=$CI_PROJECT_DIR/.m2/repository
      -Dorg.slf4j.simpleLogger.log.org.apache.maven.cli.transfer.Slf4jMavenTransferListener=WARN
      -Dorg.slf4j.simpleLogger.showDateTime=true
      -Djava.awt.headless=true
      --batch-mode --errors --fail-at-end --show-version -DinstallAtEnd=true -DdeployAtEnd=true
  image: openjdk:8-alpine

# Avec formateur Marc
#sonarcloud-check:
#  stage: sonarcloud
#  image: maven:3.6.3-jdk-11
#  cache:
#    key: "${CI_JOB_NAME}"
#    paths:
#      - .sonar/cache
#  script:
#    - mvn verify sonar:sonar
#  only:
#    - merge_requests
#    - master
#    - develop

.deploy_job:
  image: docker:stable
  script: 
    - apk add --no-cache openssh-client py3-pip python3-dev libffi-dev openssl-dev gcc libc-dev make
    - pip install docker-compose
    - export DOCKER_HOST=tcp://$PLAYWD.direct.labs.play-with-docker.com:2375
    - docker-compose build
    - docker stack deploy -c docker-compose.yml $STACK_NAME
  environment:
    name: $ENV_NAME
    url: http://$PLAYWD-8080.direct.labs.play-with-docker.com

deploy_staging_job:
  stage: deploy
  extends: 
    - .deploy_job
  variables: 
    STACK_NAME: BatStack
    ENV_NAME: staging

deploy_prod_job:
  stage: deploy
  extends: 
    - .deploy_job
  variables: 
    STACK_NAME: BatStackProd
    ENV_NAME: prod
  when: manual

#performance_job:
# stage: performance
# image: docker:git
# variables:
#  URL: http://$PLAYWD-8080.direct.labs.play-with-docker.com/
# services:
#  - docker:stable-dind
# script:
#  - apk add --no-cache curl
#  - x=1; while [[ "$(curl -s -o /dev/null -w ''%{http_code}'' http://$PLAYWD-8080.direct.labs.play-with-docker.com/)" != "200" || $x -le 60 ]]; do sleep 5; echo $(( x++ )); done || false
#  - mkdir gitlab-exporter
#  - wget -O ./gitlab-exporter/index.js https://gitlab.com/gitlab-org/gl-performance/raw/master/index.js
#  - mkdir sitespeed-results
#  - docker run --shm-size=1g --rm -v "$(pwd)":/sitespeed.io sitespeedio/sitespeed.io:6.3.1 --plugins.add ./gitlab-exporter --outputFolder sitespeed-results $URL
#  - mv sitespeed-results/data/performance.json performance.json
# artifacts:
#  paths:
#   - sitespeed-results/
#  reports:
#   performance: performance.json
